import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;


public class Algos {


    public static boolean test1TH(){
        Graphe g1 = new Graphe(5);
        g1.ajoutArete(0,1);
        g1.ajoutArete(0,2);
        g1.ajoutArete(1,2);
        g1.ajoutArete(1,3);
        g1.ajoutArete(3,4);
        g1.ajoutArete(4,1);
        return THdec(g1,1);
    }

    public static boolean test2TH(){
        Graphe g1 =new Graphe(5);
        g1.ajoutArete(0,1);
        g1.ajoutArete(0,2);
        g1.ajoutArete(1,2);
        g1.ajoutArete(1,3);
        g1.ajoutArete(3,4);
        g1.ajoutArete(1,4);

        g1.ajoutArete(0,3);
        g1.ajoutArete(0,4);
        return !THdec(g1,1) && THdec(g1,2);
    }

    public static boolean test3TH(){
        Graphe g1 =new Graphe(10);
        for(int i=0;i<10;i++){
            for(int j=0;j<10;j++){
                if(i!=j)
                    g1.ajoutArete(i,j);
            }
        }
	//on a construit g : un graphe complet à 10 sommets
        return !THdec(g1,7) && THdec(g1,8);
    }



    public static ArrayList<Integer> trouveTriangle(Graphe g){
        //en n^3 naif
        //retourne un triangle si il en existe un, et une arraylist vide sinon


        ArrayList<Integer> res = new ArrayList<>();
        Set<Integer> sommets = g.sommets();
        for(int i : sommets){
            for (int j : sommets){
                for (int k : sommets) {
                    if ((i != j) && (i != k) && (j != k) && g.existeArete(i, j) && g.existeArete(i, k) && g.existeArete(j, k)) {
                        res.add(i);
                        res.add(j);
                        res.add(k);
                        return res;
                    }
                }
            }
        }
        return res;
    }
    public static boolean THdec(Graphe g, int k){

        ArrayList<Integer> delta = trouveTriangle(g);
        if(delta.isEmpty()){
            return true;
        }
        if(k==0){
            return false;
        }

            //on essaye de prendre chaque sommet du triangle
            Graphe g1 = new Graphe(g);
            g1.supprimeSommet(delta.get(0));
            boolean res1 = THdec(g1,k-1);

            Graphe g2 = new Graphe(g);
            g2.supprimeSommet(delta.get(1));
            boolean res2 = THdec(g2,k-1);

            Graphe g3 = new Graphe(g);
            g3.supprimeSommet(delta.get(2));
            boolean res3 = THdec(g3,k-1);

            return res1 || res2 || res3;
            //rmq : le code est écrit naïvement ainsi pour bien montrer que c'est un algorithme de branchement,
            //mais il serait beaucoup mieux de d'abord tester si res1 est vrai avant de lancer les autres appels,
            //puis pareil pour res2

    }
    public static void main(String[] args){


        System.out.println("testTH1 : "+test1TH());
        System.out.println("testTH2 : "+test2TH());
        System.out.println("testTH3 : "+test3TH());

    }

}
